// MyToolBoxWnd.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "VisioDraw.h"
#include "MyToolBoxWnd.h"
#include "resource.h"
#include <io.h>
#include <direct.h>
#include <stdlib.h>
#include "NewOpenPageDlg.h"
#include "StdioFileEx.h"
#include "AddDefPortsDlg.h"

#pragma warning (disable : 4244)
#pragma warning (disable : 4800)
#pragma warning (disable : 4018)
#pragma warning (disable : 4010)
#pragma warning (disable : 4663)

#if _MSC_VER >= 1300
#include <fstream>
#include <iosfwd>
using namespace std;
#else
#include <fstream.h>
#endif

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyToolBoxWnd

CMyToolBoxWnd::CMyToolBoxWnd()
{
}

CMyToolBoxWnd::~CMyToolBoxWnd()
{
}

BEGIN_MESSAGE_MAP(CMyToolBoxWnd, CFOMultiToolBoxWnd)
	//{{AFX_MSG_MAP(CMyToolBoxWnd)
	ON_COMMAND(ID_FO_TOOLBOX_CLOSEFILE, OnFoToolboxClosefile)
	ON_COMMAND(ID_FO_TOOLBOX_LOADFILE, OnFoToolboxLoadfile)
	ON_COMMAND(ID_FO_TOOLBOX_NEWFILE, OnFoToolboxNewfile)
	ON_COMMAND(ID_FO_TOOLBOX_SAVEFILE, OnFoToolboxSavefile)
	ON_COMMAND(ID_FO_TOOLBOX_SAVEASFILE, OnFoToolboxSaveasfile)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_TOOBOX_PORT, OnTooboxPort)
	ON_UPDATE_COMMAND_UI(ID_TOOBOX_PORT, OnUpdateTooboxPort)
	ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyToolBoxWnd diagnostics

#ifdef _DEBUG
void CMyToolBoxWnd::AssertValid() const
{
	CWnd::AssertValid();
}

void CMyToolBoxWnd::Dump(CDumpContext& dc) const
{
	CWnd::Dump(dc);
}
#endif //_DEBUG
 
CMenu* CMyToolBoxWnd::CreateContextMenu()
{
	// load the menu resource
	if (m_pContextMenu)
	{
		delete m_pContextMenu;
		m_pContextMenu = NULL;
	}

	CMenu* pMenu = NULL;
	m_pContextMenu = new CMenu();
	BOOL bLoad = m_pContextMenu->LoadMenu(IDR_NEW_MENU);
	if (!bLoad)
	{
		delete m_pContextMenu;
		m_pContextMenu = NULL;
		return NULL;
	}

	pMenu = m_pContextMenu->GetSubMenu(3);

	ASSERT_VALID(pMenu);
	return pMenu;
}

BOOL CMyToolBoxWnd::ClosePage()
{
	// TODO: Add your action handler code here

	int nIndex = GetActiveIndex();

	if (nIndex == -1)
	{
		return FALSE;
	}

	int nCount = m_arPages.GetSize();
	if (nCount <= 1)
	{
		return FALSE;
	}

	RemovePage(nIndex);

	gfxData.FreeObjectCache();

	return TRUE;
}

void CMyToolBoxWnd::OpenPage(const CString &strPathName, const CString &strFileName)
{
	// TODO: Add your command handler code here

	CString strName;
	strName.LoadString(IDS_FO_NEW_TOOLBOXPAGE);
	AddPage(strName, TRUE);

	m_pToolBoxWnd->LoadResFile(strPathName);
	CString strCaption = strFileName;
	strCaption = strCaption.Left(strCaption.GetLength() - 4);
	m_pToolBoxWnd->GetCurrentPage()->SetObjectCaption(strCaption);
	if (RecalcLayout())
	{
		Invalidate(TRUE);
	}
}

BOOL CMyToolBoxWnd::FindPage(const CString &strTile)
{
	CFOToolBoxPage *pPage = NULL;
	for (int x = m_arPages.GetSize() - 1; x >= 0; x--)
	{
		pPage = (CFOToolBoxPage *)m_arPages.GetAt(x);
		if (pPage->GetObjectCaption() == strTile)
		{
			return TRUE;
		}
	}

	return FALSE;
}

static BOOL XFSetDir(const TCHAR* pcszDir)
{
#if defined( WIN32 )
	return SetCurrentDirectory(pcszDir);
#else   
	if (pcszDir != NULL && *pcszDir != '\0')
	{
		return _chdrive(_totupper(*pcszDir) - 'A' + 1) == 0 &&
			chdir(pcszDir) == 0;
	}

	return FALSE;
#endif
}

void CMyToolBoxWnd::OnFoToolboxSaveasfile()
{
	// TODO: Add your action handler code here
	CString strPathX = AfxGetApp()->m_pszHelpFilePath;
	strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
	strPathX += _T("\\Shapes\\");
	XFSetDir(strPathX);

	CString title;
	title.LoadString(IDS_FO_SAVE_FILE_TITLE);

	CString strExtx;
	strExtx.LoadString(IDS_FO_TRSFILE_EXT);
	CFileDialog dlgFile(FALSE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, strExtx, this);
	if (dlgFile.DoModal() == IDOK)
	{
		CString strFile = dlgFile.GetPathName();
		CString strExt = dlgFile.GetFileExt();
		CString strCaption = dlgFile.GetFileName();
		strExt.MakeLower();
		if (strExt == _T("trs"))
		{
			//	strFile += _T(".trs");
			m_pToolBoxWnd->SaveResFile(strFile);
			m_pToolBoxWnd->GetCurrentPage()->SetObjectCaption(strCaption);
			if (RecalcLayout())
			{
				Invalidate(TRUE);
			}
		}
		else if (strExt == _T("svg"))
		{
			m_pToolBoxWnd->GetCurrentPage()->ExportToSvg(strFile);

		}
		else if (strExt.IsEmpty())
		{
			if (dlgFile.m_ofn.nFilterIndex == 1)
			{
				strFile += _T(".trs");
				m_pToolBoxWnd->SaveResFile(strFile);
				m_pToolBoxWnd->GetCurrentPage()->SetObjectCaption(strCaption);
				if (RecalcLayout())
				{
					Invalidate(TRUE);
				}
			}
			else
			{
				strFile += _T(".svg");
				m_pToolBoxWnd->GetCurrentPage()->ExportToSvg(strFile);
			}
		}

	}
}

void CMyToolBoxWnd::GetAllPages(CStringArray &array)
{
	CFOToolBoxPage *pPage = NULL;
	for (int x = m_arPages.GetSize() - 1; x >= 0; x--)
	{
		pPage = (CFOToolBoxPage *)m_arPages.GetAt(x);

		CString str = pPage->GetObjectCaption();
		str.MakeLower();
		str.TrimLeft();
		str.TrimRight();
		array.Add(str);
	}
}



void CMyToolBoxWnd::OnCreateNewPage()
{
	// TODO: Add your command handler code here
	CString strName;
	strName.LoadString(IDS_FO_NEW_TOOLBOXPAGE);
	AddPage(strName, TRUE);
}

BOOL FOPSetDir(const TCHAR* pcszDir)
{
#if defined( WIN32 )
	return SetCurrentDirectory(pcszDir);
#else   
	if (pcszDir != NULL && *pcszDir != '\0')
	{
		return _chdrive(_totupper(*pcszDir) - 'A' + 1) == 0 &&
			chdir(pcszDir) == 0;
	}

	return FALSE;
#endif
}

BOOL FOFileExists(CString strFilePath)
{
	CFileStatus fs;
	return CFile::GetStatus(strFilePath, fs);
}

void CMyToolBoxWnd::OnTooboxPort()
{
	// TODO: Add your command handler code here
	CFOToolBoxPage *pPage = &GetActivePage();
	if (pPage != NULL)
	{
		int nTotal = pPage->GetItemList()->GetSize();
		CFOPortDefineDlg dlg(this);


		if (dlg.DoModal() != IDOK)
		{
			return;
		}
		for (int m1 = 0; m1 < nTotal; m1++)
		{
			CFOToolBoxItem *pItem = (CFOToolBoxItem *)pPage->GetItemList()->GetObject(m1);

			if (pItem != NULL && pItem->GetShape()->GetCompCount() > 0)
			{
				CFOCompositeShape *pObj = pItem->GetShape();
				pObj->RemoveAllPorts();
				FOPRect rc = pObj->GetSnapRect();
				CFODrawPortsShape *pCopp = (CFODrawPortsShape *)(pObj);

				if (dlg.m_bLeftBottom)
				{
					pCopp->CreateDefaultPort(0.0, 1.0);
				}

				if (dlg.m_bBottomCenter)
				{
					pCopp->CreateDefaultPort(0.50, 1.0);
				}

				if (dlg.m_bBottomRight)
				{
					pCopp->CreateDefaultPort(1.0, 1.0);
				}

				if (dlg.m_bCenter)
				{
					pCopp->CreateDefaultPort(0.5, 0.5);
				}


				if (dlg.m_bLeftCenter)
				{
					pCopp->CreateDefaultPort(0.0, 0.5);
				}

				if (dlg.m_bLeftTop)
				{
					pCopp->CreateDefaultPort(0.0, 0.0);
				}

				if (dlg.m_bRightCenter)
				{
					pCopp->CreateDefaultPort(1.0, 0.5);
				}

				if (dlg.m_bTopCenter)
				{
					pCopp->CreateDefaultPort(0.50, 0.0);
				}

				if (dlg.m_bTopRight)
				{
					pCopp->CreateDefaultPort(1.0, 0.0);
				}

				if (dlg.m_b0)
				{
					pCopp->CreateDefaultPort(0.25, 0.0);
				}

				if (dlg.m_b1)
				{
					pCopp->CreateDefaultPort(0.75, 0.0);
				}

				if (dlg.m_b2)
				{
					pCopp->CreateDefaultPort(1.0, 0.25);
				}

				if (dlg.m_b3)
				{
					pCopp->CreateDefaultPort(1.0, 0.75);
				}

				if (dlg.m_b4)
				{
					pCopp->CreateDefaultPort(0.75, 1.0);
				}

				if (dlg.m_b5)
				{
					pCopp->CreateDefaultPort(0.25, 1.0);
				}

				if (dlg.m_b6)
				{
					pCopp->CreateDefaultPort(0.0, 0.75);
				}

				if (dlg.m_b7)
				{
					pCopp->CreateDefaultPort(0.0, 0.25);
				}


			}
			else if (pItem != NULL)
			{
				if (1)
				{
					pItem->maPorts.RemoveAll();
				}

				if (dlg.m_bLeftBottom)
				{
					FOP_PortScale sc;
					sc.xScale = 0.0;
					sc.yScale = 1.0;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(0.0, 1.0);
				}

				if (dlg.m_bBottomCenter)
				{
					FOP_PortScale sc;
					sc.xScale = 0.50;
					sc.yScale = 1.0;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(0.50, 1.0);
				}

				if (dlg.m_bBottomRight)
				{
					FOP_PortScale sc;
					sc.xScale = 1.0;
					sc.yScale = 1.0;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(1.0, 1.0);
				}

				if (dlg.m_bCenter)
				{
					FOP_PortScale sc;
					sc.xScale = 0.50;
					sc.yScale = 0.50;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(0.5, 0.5);
				}


				if (dlg.m_bLeftCenter)
				{
					FOP_PortScale sc;
					sc.xScale = 0.0;
					sc.yScale = 0.50;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(0.0, 0.5);
				}

				if (dlg.m_bLeftTop)
				{
					FOP_PortScale sc;
					sc.xScale = 0.0;
					sc.yScale = 0.0;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(0.0, 0.0);
				}

				if (dlg.m_bRightCenter)
				{
					FOP_PortScale sc;
					sc.xScale = 1.0;
					sc.yScale = 0.50;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//		pCopp->CreateDefaultPort(1.0, 0.5);
				}

				if (dlg.m_bTopCenter)
				{
					FOP_PortScale sc;
					sc.xScale = 0.50;
					sc.yScale = 0.0;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//		pCopp->CreateDefaultPort(0.50, 0.0);
				}

				if (dlg.m_bTopRight)
				{
					FOP_PortScale sc;
					sc.xScale = 1.0;
					sc.yScale = 0.0;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(1.0, 0.0);
				}

				if (dlg.m_b0)
				{
					FOP_PortScale sc;
					sc.xScale = 0.25;
					sc.yScale = 0.0;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(0.25, 0.0);
				}

				if (dlg.m_b1)
				{
					FOP_PortScale sc;
					sc.xScale = 0.75;
					sc.yScale = 0.0;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(0.75, 0.0);
				}

				if (dlg.m_b2)
				{
					FOP_PortScale sc;
					sc.xScale = 1.0;
					sc.yScale = 0.25;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//pCopp->CreateDefaultPort(1.0, 0.25);
				}

				if (dlg.m_b3)
				{
					FOP_PortScale sc;
					sc.xScale = 1.0;
					sc.yScale = 0.75;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(1.0, 0.75);
				}

				if (dlg.m_b4)
				{
					FOP_PortScale sc;
					sc.xScale = 0.75;
					sc.yScale = 1.0;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(0.75, 1.0);
				}

				if (dlg.m_b5)
				{
					FOP_PortScale sc;
					sc.xScale = 0.25;
					sc.yScale = 1.0;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(0.25, 1.0);
				}

				if (dlg.m_b6)
				{
					FOP_PortScale sc;
					sc.xScale = 0.0;
					sc.yScale = 0.75;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(0.0, 0.75);
				}

				if (dlg.m_b7)
				{
					FOP_PortScale sc;
					sc.xScale = 0.0;
					sc.yScale = 0.25;
					sc.nLinkType = 0;
					sc.nPortType = 0;
					pItem->maPorts.Add(sc);
					//	pCopp->CreateDefaultPort(0.0, 0.25);
				}

			}

			pPage->SetModifyFlag();
		}
	}
}

void CMyToolBoxWnd::OnUpdateTooboxPort(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	 
}

void CMyToolBoxWnd::OnCreateSavePage()
{
	// TODO: Add your command handler code here
	if (GetToolBoxWnd()->GetCurrentPage()->m_strFileName.IsEmpty())
	{
		CString strPathX = AfxGetApp()->m_pszHelpFilePath;
		strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
		FOPSetDir(strPathX);

		//		CString title;
		//		title.LoadString(IDS_FO_SAVE_FILE_TITLE);

		//		CString strExt;
		//		strExt.LoadString(IDS_FO_TRSFILE_EXT);
		//		CFileDialog dlgFile (FALSE,NULL,NULL,OFN_HIDEREADONLY| OFN_OVERWRITEPROMPT,strExt,this);
		//		if(dlgFile.DoModal() == IDOK)
	fopDoStart0311:
		CFORenameDlg dlg;
		if (dlg.DoModal() == IDOK)
		{
			CString strFile = dlg.m_strCaption;
			CString strExt = strFile.Right(3);
			CString strCaption = strFile;
			CString strSave = strCaption;
			strExt.MakeLower();
			if (strExt != _T("trs"))
			{
				strFile += _T(".trs");
				strSave += _T(".trs");
			}
			else
			{
				strCaption = strCaption.Left(strCaption.GetLength() - 4);
			}

			strFile = strPathX + _T("\\Shapes\\") + strFile;
			if (FOFileExists(strFile))
			{
				goto fopDoStart0311;
			}

			GetToolBoxWnd()->SaveResFile(strFile);
			GetToolBoxWnd()->GetCurrentPage()->SetObjectCaption(strCaption);
			if (RecalcLayout())
			{
				Invalidate(TRUE);
			}

			CStringArray m_Files;

			CString strOtherFile;
			strOtherFile = strPathX + _T("\\Shapes\\index.dat");
			CStdioFile m_File;
			if (m_File.Open(strOtherFile, CFile::modeRead | CFile::typeText))
			{
				CString strTemp;
				int nNumber = 100;
				while (m_File.ReadString(strTemp))
				{
					strTemp.TrimLeft();
					strTemp.TrimRight();
					if (!strTemp.IsEmpty())
					{
						m_Files.Add(strTemp);
					}
				}
				m_File.Close();
			}

			CString strFileName;
			strFileName = strOtherFile;// File name

			CStdioFile fileWriteUnicode;

			if (fileWriteUnicode.Open(strFileName,
				CFile::modeCreate | CFile::modeWrite))
			{
				for (int x = 0; x < m_Files.GetSize(); x++)
				{
					CString str = m_Files.GetAt(x);
					fileWriteUnicode.WriteString(str + _T("\n"));
				}

				CString strCur;
				strCur.Format(_T("%u#%s"), m_Files.GetSize(), strSave);
				fileWriteUnicode.WriteString(strCur + _T("\n"));

				fileWriteUnicode.Close();
			}
		}
	}
	else
	{
		GetToolBoxWnd()->GetCurrentPage()->SetModifyFlag(TRUE);
		GetToolBoxWnd()->SaveFile();
	}


}

CString FOPGetFileName(const CString& strFullPath)
{
	CString strFile = strFullPath;
	int nIndex = strFile.ReverseFind(_T('\\'));
	int nIndex2 = strFile.ReverseFind(_T('/'));
	if (nIndex2 > nIndex)
		nIndex = nIndex2;

	if (nIndex >= 0)
	{
		strFile = strFile.Right(strFile.GetLength() - nIndex - 1);
	}

	return strFile;
}

void CMyToolBoxWnd::OpenPage2(CString strSelectFile)
{
	// TODO: Add your command handler code here

	CString strPathX = AfxGetApp()->m_pszHelpFilePath;
	strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
	FOPSetDir(strPathX);


	{
		if (!strSelectFile.IsEmpty())
		{
			CString strFile = strSelectFile + _T(".trs");

			CString strSave = strFile;

			CString strOtherFile;
			strOtherFile = strPathX + _T("\\Shapes\\") + strFile;

			m_pToolBoxWnd->LoadResFile(strOtherFile);
			CString strCaption = strFile;
			strCaption = strCaption.Left(strCaption.GetLength() - 4);
			m_pToolBoxWnd->GetCurrentPage()->SetObjectCaption(strCaption);
			gfxData.FreeObjectCache();
			if (RecalcLayout())
			{
				Invalidate(TRUE);
			}

		}
	}
}

void CMyToolBoxWnd::OnRemovePage()
{
	// TODO: Add your command handler code here
	CString strMsg = FOPGetFileName(GetToolBoxWnd()->GetCurrentPage()->m_strFileName);
	strMsg = strMsg.Left(strMsg.GetLength() - 4);
	strMsg += _T("\n\n");
	strMsg += _T("Do you make sure you really need to remove this page?");

	if (GetToolBoxWnd()->GetCurrentPage()->m_strFileName.IsEmpty())
	{
		ClosePage();
	}
	else// if(AfxMessageBox(strMsg,
		//		MB_YESNO|MB_ICONINFORMATION) == IDYES)
	{
		CString strxx = GetToolBoxWnd()->GetCurrentPage()->GetObjectCaption();
		strxx += _T(".trs");
		if (!ClosePage())
			return;

		CString strPathX = AfxGetApp()->m_pszHelpFilePath;
		strPathX = strPathX.Left(strPathX.ReverseFind('\\'));

		CStringArray m_Files;
		CString strOtherFile;
		strOtherFile = strPathX + _T("\\Shapes\\index.dat");
		CStdioFile m_File;
		if (m_File.Open(strOtherFile, CFile::modeRead | CFile::typeText))
		{
			CString strTemp;
			int nNumber = 100;
			while (m_File.ReadString(strTemp))
			{
				strTemp.TrimLeft();
				strTemp.TrimRight();
				if (!strTemp.IsEmpty())
				{
					CString strTitle;
					CString strFile;
					strTitle = strTemp.Left(strTemp.ReverseFind('#'));
					strFile = strTemp.Right(strTemp.GetLength() - strTitle.GetLength() - 1);
					if ((!strTitle.IsEmpty()) && (!strFile.IsEmpty()))
					{
						if (strFile != strxx)
							m_Files.Add(strTemp);
					}
				}
			}
			m_File.Close();
		}

		CString strFileName;
		strFileName = strOtherFile;// File name

		CStdioFile fileWriteUnicode;

		if (fileWriteUnicode.Open(strFileName,
			CFile::modeCreate | CFile::modeWrite))
		{
			for (int x = 0; x < m_Files.GetSize(); x++)
			{
				CString str = m_Files.GetAt(x);
				fileWriteUnicode.WriteString(str + _T("\n"));
			}

			fileWriteUnicode.Close();
		}
	}
}

void CMyToolBoxWnd::DoOpenPage(const CString &strFile)
{

	CString strTile;
	strTile = theApp.XGetFileName(strFile);
	OpenPage(strFile, strTile);

}

void CMyToolBoxWnd::OnOpenPage()
{
	// TODO: Add your command handler code here

	CString strPathX = AfxGetApp()->m_pszHelpFilePath;
	strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
	FOPSetDir(strPathX);

	CNewOpenPageDlg dlgFile;
	GetAllPages(dlgFile.m_array);
	if (dlgFile.DoModal() == IDOK)
	{
		if (!dlgFile.strSelectFile.IsEmpty())
		{
			CString strFile = dlgFile.strSelectFile + _T(".trs");

			CString strSave = strFile;

			CString strOtherFile;
			strOtherFile = strPathX + _T("\\Shapes\\") + strFile;
			OpenPage(strOtherFile, strFile);

			CString strPathX = AfxGetApp()->m_pszHelpFilePath;
			strPathX = strPathX.Left(strPathX.ReverseFind('\\'));

			{
				CStringArray m_Files;
				CString strOtherFile;
				strOtherFile = strPathX + _T("\\Shapes\\index.dat");
				CStdioFile m_File;
				if (m_File.Open(strOtherFile, CFile::modeRead | CFile::typeText))
				{
					CString strTemp;
					int nNumber = 100;
					while (m_File.ReadString(strTemp))
					{
						strTemp.TrimLeft();
						strTemp.TrimRight();
						if (!strTemp.IsEmpty())
						{
							CString strTitle;
							CString strFile;
							strTitle = strTemp.Left(strTemp.ReverseFind('#'));
							strFile = strTemp.Right(strTemp.GetLength() - strTitle.GetLength() - 1);
							if ((!strTitle.IsEmpty()) && (!strFile.IsEmpty()))
							{
								m_Files.Add(strTemp);
							}
						}
					}
					m_File.Close();
				}

				CString strFileName;
				strFileName = strOtherFile;// File name

				CStdioFile fileWriteUnicode;

				if (fileWriteUnicode.Open(strFileName,
					CFile::modeCreate | CFile::modeWrite))
				{
					for (int x = 0; x < m_Files.GetSize(); x++)
					{
						CString str = m_Files.GetAt(x);
						fileWriteUnicode.WriteString(str + _T("\n"));
					}

					CString strCur;
					strCur.Format(_T("%u#%s"), m_Files.GetSize(), strSave);
					fileWriteUnicode.WriteString(strCur + _T("\n"));

					fileWriteUnicode.Close();
				}
			}
		}
	}
}

void CMyToolBoxWnd::OnFoToolboxClosefile()
{
	// TODO: Add your action handler code here
	OnRemovePage();
}

void CMyToolBoxWnd::OnFoToolboxLoadfile()
{
	// TODO: Add your action handler code here
	OnOpenPage();
}

void CMyToolBoxWnd::OnFoToolboxNewfile()
{
	// TODO: Add your action handler code here
	OnCreateNewPage();
}

void CMyToolBoxWnd::OnFoToolboxSavefile()
{
	// TODO: Add your action handler code here
	CString strPathX = AfxGetApp()->m_pszHelpFilePath;
	strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
	strPathX += _T("\\Shapes\\");
	XFSetDir(strPathX);

	OnCreateSavePage();
}

void CMyToolBoxWnd::DoCreateToolBoxPageWnd()
{
	m_pToolBoxWnd = new CMyToolBoxPageWnd;
}

/////////////////////////////////////////////////////////////////////////////
// CMyToolBoxPageWnd

CMyToolBoxPageWnd::CMyToolBoxPageWnd()
{
}

CMyToolBoxPageWnd::~CMyToolBoxPageWnd()
{
}

BEGIN_MESSAGE_MAP(CMyToolBoxPageWnd, CFOToolBoxPageWnd)
	//{{AFX_MSG_MAP(CMyToolBoxPageWnd)
	   
	ON_COMMAND(ID_TOOBOX_PORT, OnTooboxPort)
	ON_UPDATE_COMMAND_UI(ID_TOOBOX_PORT, OnUpdateTooboxPort)
	//	ON_COMMAND(ID_COMP_BUTTON_DESIGN, OnCompButtonDesign)
	//	ON_UPDATE_COMMAND_UI(ID_COMP_BUTTON_DESIGN, OnUpdateCompButtonDesign)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL FODirectoryExists(const CString& Path)
{
#ifdef WIN32
	DWORD dwRetVal = GetFileAttributes(Path);
	if (dwRetVal == 0xFFFFFFFF)
		return FALSE;

	else if (dwRetVal & FILE_ATTRIBUTE_DIRECTORY)
		return TRUE;

	return FALSE;
#else
	CFileStatus FileStatus;

	if (CFile::GetStatus(Path, FileStatus) == TRUE  &&
		FileStatus.m_attribute & directory)
	{
		return TRUE;
	}
	else if (FOFileSystemExists(GetFullPathName(Path)))
	{
		return TRUE;
	}

	return FALSE;
#endif
}

BOOL FOMakeDirectory(const CString& NewDirectory)
{
#ifdef WIN32

	SECURITY_ATTRIBUTES security_attrib;
	security_attrib.nLength = sizeof(SECURITY_ATTRIBUTES);
	security_attrib.lpSecurityDescriptor = NULL;
	security_attrib.bInheritHandle = TRUE;

	BOOL bRetVal = CreateDirectory((const TCHAR *)NewDirectory, &security_attrib);
	return bRetVal;

#else

	int nRetVal = _tmkdir((const char *)NewDirectory);
	if (nRetVal == -1)
	{
		return FALSE;
	}

	return TRUE;

#endif
}

BOOL FOMakePath(const CString& NewDirectory)
{
	CString NewDir = NewDirectory;
	CString  DirName;
	BOOL    bRetVal = TRUE;

	if (NewDir.GetLength() == 0)
	{
		return FALSE;
	}

	if (NewDir[NewDir.GetLength() - 1] != '\\')
	{
		NewDir = NewDir + '\\';
	}

	UINT  nIndex = 0;
	BOOL  bDone = FALSE;
	while (!bDone)
	{
		nIndex = NewDir.Find('\\');
		if (nIndex != -1)
		{
			DirName = DirName + NewDir.Left(nIndex);
			NewDir = NewDir.Right(NewDir.GetLength() - nIndex - 1);

			if (DirName.GetLength() >= 1 && DirName[DirName.GetLength() - 1] != ':')
			{
				bRetVal = FOMakeDirectory(DirName);
			}
			DirName = DirName + '\\';
		}
		else
		{
			bDone = TRUE;
		}
	}

	return bRetVal;
}

void CMyToolBoxPageWnd::DoAfterAdd()
{
//	theApp.mbPageChanged = TRUE;
}

BOOL CMyToolBoxPageWnd::DoSaveResFile()
{
	if (GetCurrentPage()->m_strFileName.IsEmpty())
	{
		CString strPathX = AfxGetApp()->m_pszHelpFilePath;
		strPathX = strPathX.Left(strPathX.ReverseFind('\\'));

		CString strCheck = strPathX + _T("\\Shapes\\");
		if (!FODirectoryExists(strCheck))
		{
			FOMakePath(strCheck);
		}

		FOPSetDir(strPathX);

		//		CString title;
		//		title.LoadString(IDS_FO_SAVE_FILE_TITLE);

		//		CString strExt;
		//		strExt.LoadString(IDS_FO_TRSFILE_EXT);
		//		CFileDialog dlgFile (FALSE,NULL,NULL,OFN_HIDEREADONLY| OFN_OVERWRITEPROMPT,strExt,this);
		//		if(dlgFile.DoModal() == IDOK)
	fopDoStart0311:
		CFORenameDlg dlg;
		if (dlg.DoModal() == IDOK)
		{
			CString strFile = dlg.m_strCaption;
			CString strExt = strFile.Right(3);
			CString strCaption = strFile;
			CString strSave = strCaption;
			strExt.MakeLower();
			if (strExt != _T("trs"))
			{
				strFile += _T(".trs");
				strSave += _T(".trs");
			}
			else
			{
				strCaption = strCaption.Left(strCaption.GetLength() - 4);
			}

			strFile = strPathX + _T("\\Shapes\\") + strFile;
			if (FOFileExists(strFile))
			{
				goto fopDoStart0311;
			}

			GetCurrentPage()->m_strFileName = strFile;
			SaveResFile(strFile);
			GetCurrentPage()->SetObjectCaption(strCaption);
			//			if( RecalcLayout())
			{
				Invalidate(TRUE);
			}

			CStringArray m_Files;

			CString strOtherFile;
			strOtherFile = strPathX + _T("\\Shapes\\matlab.dat");
			CStdioFile m_File;
			if (m_File.Open(strOtherFile, CFile::modeRead | CFile::typeText))
			{
				CString strTemp;
				int nNumber = 100;
				while (m_File.ReadString(strTemp))
				{
					strTemp.TrimLeft();
					strTemp.TrimRight();
					if (!strTemp.IsEmpty())
					{
						m_Files.Add(strTemp);
					}
				}
				m_File.Close();
			}

			CString strFileName;
			strFileName = strOtherFile;// File name

			CStdioFile fileWriteUnicode;

			if (fileWriteUnicode.Open(strFileName,
				CFile::modeCreate | CFile::modeWrite))
			{
				for (int x = 0; x < m_Files.GetSize(); x++)
				{
					CString str = m_Files.GetAt(x);
					fileWriteUnicode.WriteString(str + _T("\n"));
				}

				CString strCur;
				strCur.Format(_T("%u#%s"), m_Files.GetSize(), strSave);
				fileWriteUnicode.WriteString(strCur + _T("\n"));

				fileWriteUnicode.Close();
			}

		}
	}
	else
	{
		GetCurrentPage()->SetModifyFlag(TRUE);
		SaveFile();
		gfxData.FreeObjectCache();
	}

	return TRUE;
}

CMenu * CMyToolBoxPageWnd::CreateSubContextMenu()
{
	if (m_pContextMenu)
		delete m_pContextMenu;

	CMenu* pMenu;
	m_pContextMenu = new CMenu();
	m_pContextMenu->LoadMenu(IDR_NEW_MENU);

	pMenu = m_pContextMenu->GetSubMenu(2);

	ASSERT_VALID(pMenu);
	return pMenu;
}

BOOL X_FindWithIndex(CStringArray &m_Array, const CString &strValue)
{
	for (int x = 0; x < m_Array.GetSize(); x++)
	{
		CString nCur = m_Array.GetAt(x);
		if (nCur == strValue)
		{
			return TRUE;
		}
	}

	return FALSE;
}

CString X_GetCorrectValue(CStringArray &m_Array, CString strCorrect)
{
	int nCorrect = 0;
	for (;;)
	{
		if (X_FindWithIndex(m_Array, strCorrect) || strCorrect.IsEmpty())
		{
			nCorrect++;
			strCorrect.Format(_T("K%u"), nCorrect);
		}
		else
		{
			return strCorrect;
		}
	}

	return strCorrect;
}

void CMyToolBoxPageWnd::OnAddState()
{
	// TODO: Add your command handler code here
	 
}

void CMyToolBoxPageWnd::OnUpdateAddState(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	 
}


void CMyToolBoxPageWnd::OnChangeAllProp()
{
	// TODO: Add your command handler code here
	 
}

void CMyToolBoxPageWnd::OnUpdateChangeAllProp(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	 
}


void CMyToolBoxPageWnd::OnCompButtonDesign()
{
	// TODO: Add your command handler code here
	CFOToolBoxItem *pHitItem = (CFOToolBoxItem *)GetSelected();
	if (pHitItem != NULL)
	{
		if (pHitItem->GetShape()->GetCompCount() > 0)
		{
			CFOCompositeShape *pComp = static_cast<CFOCompositeShape *>(pHitItem->GetShape());

			BOOL bAlowHitChild = FALSE;
			pComp->GetPropBoolValue(bAlowHitChild, P_ID_ALLOW_HIT_CHILD);

			BOOL bButtonClick = FALSE;
			pComp->GetPropBoolValue(bButtonClick, P_ID_WITH_TWO_BUTTONCLICK);

			BOOL bStatus = FALSE;
			pComp->GetPropBoolValue(bStatus, P_ID_WITH_TWO_STATUS);

			BOOL bCycle = FALSE;
			pComp->GetPropBoolValue(bCycle, P_ID_WITH_CYCLE_ANIMATE);


		}
	}
}

void CMyToolBoxPageWnd::OnUpdateCompButtonDesign(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	CFOToolBoxItem *pHitItem = (CFOToolBoxItem *)GetSelected();
	pCmdUI->Enable(FALSE);
	if (pHitItem != NULL)
	{
		pCmdUI->Enable(pHitItem->GetShape()->GetCompCount() > 0);
	}
}

CFOPortShape *CMyToolBoxPageWnd::CreatePort(const FOPRect &rcNew, CFODrawPortsShape *pMain)
{

	CFOPortShape *pReturn = new CFOPortShape;
	pReturn->AddRef();
	pReturn->Create(rcNew.Center(), NULL);
	pReturn->SetScale(0.2, 0.8);
	pReturn->UpdatePosition();

	pReturn->SetMainShape(pMain);

	pMain->AddNewPort(pReturn);
	pReturn->Release();
	return pReturn;

}

void CMyToolBoxPageWnd::OnTooboxPort()
{
	// TODO: Add your command handler code here
	CFOToolBoxItem *pItem = (CFOToolBoxItem *)GetSelected();

	if (pItem != NULL)
	{
		int nTotal = pItem->GetShape()->GetCompCount();
		CFOCompositeShape *pObj = pItem->GetShape();
		//   if (nTotal == 1)
		//      pObj = theDragItem->m_pCompositeShape->GetObj(0);

		if (pObj != NULL && pObj->GetCompCount() > 0)
		{
			CFOPortDefineDlg dlg(this);


			if (dlg.DoModal() != IDOK)
			{
				return;
			}

			if (1)
			{
				pObj->RemoveAllPorts();
			}

			FOPRect rc = pObj->GetSnapRect();
			CFODrawPortsShape *pCopp = (CFODrawPortsShape *)(pObj);

			if (dlg.m_bLeftBottom)
			{
				pCopp->CreateDefaultPort(0.0, 1.0);
			}

			if (dlg.m_bBottomCenter)
			{
				pCopp->CreateDefaultPort(0.50, 1.0);
			}

			if (dlg.m_bBottomRight)
			{
				pCopp->CreateDefaultPort(1.0, 1.0);
			}

			if (dlg.m_bCenter)
			{
				pCopp->CreateDefaultPort(0.5, 0.5);
			}


			if (dlg.m_bLeftCenter)
			{
				pCopp->CreateDefaultPort(0.0, 0.5);
			}

			if (dlg.m_bLeftTop)
			{
				pCopp->CreateDefaultPort(0.0, 0.0);
			}

			if (dlg.m_bRightCenter)
			{
				pCopp->CreateDefaultPort(1.0, 0.5);
			}

			if (dlg.m_bTopCenter)
			{
				pCopp->CreateDefaultPort(0.50, 0.0);
			}

			if (dlg.m_bTopRight)
			{
				pCopp->CreateDefaultPort(1.0, 0.0);
			}

			if (dlg.m_b0)
			{
				pCopp->CreateDefaultPort(0.25, 0.0);
			}

			if (dlg.m_b1)
			{
				pCopp->CreateDefaultPort(0.75, 0.0);
			}

			if (dlg.m_b2)
			{
				pCopp->CreateDefaultPort(1.0, 0.25);
			}

			if (dlg.m_b3)
			{
				pCopp->CreateDefaultPort(1.0, 0.75);
			}

			if (dlg.m_b4)
			{
				pCopp->CreateDefaultPort(0.75, 1.0);
			}

			if (dlg.m_b5)
			{
				pCopp->CreateDefaultPort(0.25, 1.0);
			}

			if (dlg.m_b6)
			{
				pCopp->CreateDefaultPort(0.0, 0.75);
			}

			if (dlg.m_b7)
			{
				pCopp->CreateDefaultPort(0.0, 0.25);
			}

			GetCurrentPage()->SetModifyFlag();
		}
		else if (pObj != NULL)
		{
			CFOPortDefineDlg dlg(this);


			if (dlg.DoModal() != IDOK)
			{
				return;
			}

			if (1)
			{
				pItem->maPorts.RemoveAll();
			}

			FOPRect rc = pObj->GetSnapRect();
			CFODrawPortsShape *pCopp = (CFODrawPortsShape *)(pObj);

			if (dlg.m_bLeftBottom)
			{
				FOP_PortScale sc;
				sc.xScale = 0.0;
				sc.yScale = 1.0;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(0.0, 1.0);
			}

			if (dlg.m_bBottomCenter)
			{
				FOP_PortScale sc;
				sc.xScale = 0.50;
				sc.yScale = 1.0;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(0.50, 1.0);
			}

			if (dlg.m_bBottomRight)
			{
				FOP_PortScale sc;
				sc.xScale = 1.0;
				sc.yScale = 1.0;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(1.0, 1.0);
			}

			if (dlg.m_bCenter)
			{
				FOP_PortScale sc;
				sc.xScale = 0.50;
				sc.yScale = 0.50;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(0.5, 0.5);
			}


			if (dlg.m_bLeftCenter)
			{
				FOP_PortScale sc;
				sc.xScale = 0.0;
				sc.yScale = 0.50;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(0.0, 0.5);
			}

			if (dlg.m_bLeftTop)
			{
				FOP_PortScale sc;
				sc.xScale = 0.0;
				sc.yScale = 0.0;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(0.0, 0.0);
			}

			if (dlg.m_bRightCenter)
			{
				FOP_PortScale sc;
				sc.xScale = 1.0;
				sc.yScale = 0.50;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//		pCopp->CreateDefaultPort(1.0, 0.5);
			}

			if (dlg.m_bTopCenter)
			{
				FOP_PortScale sc;
				sc.xScale = 0.50;
				sc.yScale = 0.0;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//		pCopp->CreateDefaultPort(0.50, 0.0);
			}

			if (dlg.m_bTopRight)
			{
				FOP_PortScale sc;
				sc.xScale = 1.0;
				sc.yScale = 0.0;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(1.0, 0.0);
			}

			if (dlg.m_b0)
			{
				FOP_PortScale sc;
				sc.xScale = 0.25;
				sc.yScale = 0.0;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(0.25, 0.0);
			}

			if (dlg.m_b1)
			{
				FOP_PortScale sc;
				sc.xScale = 0.75;
				sc.yScale = 0.0;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(0.75, 0.0);
			}

			if (dlg.m_b2)
			{
				FOP_PortScale sc;
				sc.xScale = 1.0;
				sc.yScale = 0.25;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//pCopp->CreateDefaultPort(1.0, 0.25);
			}

			if (dlg.m_b3)
			{
				FOP_PortScale sc;
				sc.xScale = 1.0;
				sc.yScale = 0.75;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(1.0, 0.75);
			}

			if (dlg.m_b4)
			{
				FOP_PortScale sc;
				sc.xScale = 0.75;
				sc.yScale = 1.0;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(0.75, 1.0);
			}

			if (dlg.m_b5)
			{
				FOP_PortScale sc;
				sc.xScale = 0.25;
				sc.yScale = 1.0;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(0.25, 1.0);
			}

			if (dlg.m_b6)
			{
				FOP_PortScale sc;
				sc.xScale = 0.0;
				sc.yScale = 0.75;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(0.0, 0.75);
			}

			if (dlg.m_b7)
			{
				FOP_PortScale sc;
				sc.xScale = 0.0;
				sc.yScale = 0.25;
				sc.nLinkType = 0;
				sc.nPortType = 0;
				pItem->maPorts.Add(sc);
				//	pCopp->CreateDefaultPort(0.0, 0.25);
			}

			GetCurrentPage()->SetModifyFlag();
		}
	}

}

void CMyToolBoxPageWnd::OnUpdateTooboxPort(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	CFOToolBoxItem *pHitItem = (CFOToolBoxItem *)GetSelected();
	pCmdUI->Enable(FALSE);
	if (pHitItem != NULL)
	{
		pCmdUI->Enable(pHitItem != NULL);
	}
}
