// SVSaveAsTemplateDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VisioDraw.h"
#include "SVSaveAsTemplateDlg.h"
#include <direct.h>
#include "MBTemplageDlg.h"
#include "PublishDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSVSaveAsTemplateDlg dialog


CSVSaveAsTemplateDlg::CSVSaveAsTemplateDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSVSaveAsTemplateDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSVSaveAsTemplateDlg)
	m_strName = _T("Template");
	m_strType = _T("");
	m_strCategoryName = _T("Folder");
	m_strPage = _T("");
	//}}AFX_DATA_INIT
	m_strPath = _T("");
//	EnableVisualManagerStyle(TRUE, TRUE);
	m_strImage = _T("");
}

void CSVSaveAsTemplateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSVSaveAsTemplateDlg)
	DDX_Control(pDX, ID_SV_SAVE_AS_TEMPLATE_DLG_TYPE, m_cbType);
	DDX_Text(pDX, ID_SV_SAVE_AS_TEMPLATE_DLG_NAME, m_strName);
	DDX_CBString(pDX, ID_SV_SAVE_AS_TEMPLATE_DLG_TYPE, m_strType);
	DDX_Text(pDX, ID_SV_SAVE_AS_TEMPLATE_NEW_NAME, m_strCategoryName);
	DDX_Text(pDX, IDC_EDIT_PAGE, m_strPage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSVSaveAsTemplateDlg, CDialog)
	//{{AFX_MSG_MAP(CSVSaveAsTemplateDlg)
	ON_BN_CLICKED(ID_SV_SAVE_AS_TEMPLATE_DLG_CREATE, OnSvSaveAsTemplateDlgCreate)
	ON_BN_CLICKED(ID_SV_SAVE_AS_TEMPLATE_REMOVE, OnSvSaveAsTemplateRemove)
	ON_BN_CLICKED(IDC_BUTTON_PAGE, OnButtonPage)
	ON_BN_CLICKED(IDC_BUTTON_IMAGE, OnButtonImage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSVSaveAsTemplateDlg message handlers

BOOL CSVSaveAsTemplateDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	SetIcon(AfxGetApp()->LoadIcon(IDR_VisioDrawTYPE), TRUE);
	
	// TODO: Add extra initialization here
	//	
	CFileFind ff;
	BOOL res = ff.FindFile(XD::g_GetTemplateFolder() + _T("\\*.*"));

	while(res)
	{
		res = ff.FindNextFile();
		if(ff.IsDirectory() && !ff.IsDots())//
		{
			//
			m_cbType.AddString(ff.GetFileTitle());
			m_cbType.SetCurSel(0);
		}
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL FOPFileExist12(CString strFilePath)
{
	CFileStatus fs;
	return CFile::GetStatus(strFilePath, fs);
}

void CSVSaveAsTemplateDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);

	if (m_strType == _T("") || m_strName == _T(""))
	{
		GetDlgItem(ID_SV_SAVE_AS_TEMPLATE_DLG_NAME)->SetFocus();
		return;
	}
	
	m_strPath = XD::g_GetTemplateFolder() + _T("\\") + m_strType + _T("\\") + m_strName + _T(".tfm");
	if(FOPFileExist12(m_strPath))
	{
		MessageBox(_T("The name is used, please enter a new one and try again!"), _T("UCanCode"),MB_OK|MB_ICONINFORMATION);
		GetDlgItem(ID_SV_SAVE_AS_TEMPLATE_DLG_NAME)->SetFocus();
		return;
	}

	if(m_strPage.IsEmpty())
	{
		AfxMessageBox(_T("You must select some pages for publish, please try again!"), MB_OK|MB_ICONINFORMATION);
		GetDlgItem(IDC_EDIT_PAGE)->SetFocus();
		return;
	}
	CDialog::OnOK();
}

void CSVSaveAsTemplateDlg::OnSvSaveAsTemplateDlgCreate() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_strCategoryName == _T("")) return;

	int nIndex = m_cbType.FindString(0, m_strCategoryName);
	if (CB_ERR != nIndex)
	{
		m_cbType.SetCurSel(nIndex);
		return;
	}

	CString strPath = XD::g_GetTemplateFolder() + _T("\\") + m_strCategoryName;
	if( _tmkdir(strPath.GetBuffer(strPath.GetLength())) == 0 )
	{
	//	CString strTemp;
//		strTemp.Format(IDS_SV_CREATE_CATEGORY_OK, m_strCategoryName);
	//	theApp.ShowMessage(strTemp);
		m_cbType.SetCurSel(m_cbType.AddString(m_strCategoryName));
	}
	else
	{
		AfxMessageBox(_T("This file folder is already exists, please try again!"), MB_ICONERROR|MB_OK);
	//	CString strTemp;
	//	strTemp.Format(IDS_SV_CREATE_CATEGORY_FAILD, m_strCategoryName);
	//	theApp.ShowMessage(strTemp);
	}

	strPath.ReleaseBuffer();
}

void CSVSaveAsTemplateDlg::OnSvSaveAsTemplateRemove() 
{
	UpdateData(TRUE);
	// TODO: Add your control notification handler code here
	if (m_strType == _T(""))
		return;

	CString strPath = XD::g_GetTemplateFolder() + _T("\\") + m_strType;

//	CString strTemp = _T("");
//	strTemp.Format(IDS_SV_REMOVE_CATEGORY, m_strType);
//	if (IDYES != theApp.ShowMessage(strTemp, MB_YESNO))
//		return;

	if( _trmdir(strPath.GetBuffer(strPath.GetLength())) == 0 )
	{
	//	strTemp.Format(IDS_SV_REMOVE_CATEGORY_SUCCESS, m_strType);
	//	theApp.ShowMessage(strTemp);
		if (CB_ERR != m_cbType.GetCurSel())
			m_cbType.DeleteString(m_cbType.GetCurSel());
	}
	else
	{
	//	strTemp.Format(IDS_SV_REMOVE_CATEGORY_FIELD, m_strType);
	//	theApp.ShowMessage(strTemp);
	}

	strPath.ReleaseBuffer();
}

void CSVSaveAsTemplateDlg::OnButtonPage() 
{
	// TODO: Add your control notification handler code here
	CPublishDlg dlg;
	dlg.strPages = m_strPage;
	if(dlg.DoModal() == IDOK)
	{
		m_strPage = dlg.strPages;
		GetDlgItem(IDC_EDIT_PAGE)->SetWindowText(m_strPage);
	}
}

void CSVSaveAsTemplateDlg::OnButtonImage() 
{
	// TODO: Add your control notification handler code here
	CString title;
	title.LoadString(IDS_FO_OPEN_FILE_TITLE);
	
	CString strFilter;
	strFilter.LoadString(IDS_FO_IMAGE_EXTENSION);
	
	CFileDialog dlgFile (TRUE,NULL,NULL,OFN_HIDEREADONLY| OFN_OVERWRITEPROMPT,
		_T("Png Files(*.png)|*.png||"),this);
	if(dlgFile.DoModal() == IDOK)
	{
		m_strImage = dlgFile.GetPathName();
		GetDlgItem(IDC_EDIT_FILE)->SetWindowText(m_strImage);
		
	}
}
